#include <iostream>
// Ukljucujemo zaglavlje algorithm kako bismo mogli da koristimo algoritme standardne biblioteke
#include <algorithm>
#include <vector>

int main ()
{
    std::vector<int> a = {1,2,3,4,5,6,7,8,9};
    std::vector<int> b (a.size());
  
    // std::copy_if iz kolekcije a kopira u kolekciju b sve elemente koji zadovoljavaju uslov
    // Za kolekciju b moramo da alociramo memoriju i to a.size() jer je moguce da svi elementi kolekcije a zadovoljavaju uslov
    // Kao povratnu vrednost dobijamo iterator na jednu poziciju iza poslednjeg elementa koji je dodat u kolekciju b
    auto last = std::copy_if(a.begin(), a.end(), b.begin(), [](int x){ return x % 2; });

    // Ispis kolekcije b
    // Idemo samo do last jer mozda imamo i prazna mesta u kolekciji b.
    // Ako se npr desilo da od 100 elemenata kolekcije a samo 10 zadovoljava uslov, onda cemo dobiti iterator na 11 poziciju u kolekciji b i ispisivati samo prvih 10 elemenata.
    // Ako idemo do b.end() dobicemo svih 100 elemenata sto mozda nije ispravno
    // Izmeniti last u b.end() i videti ponasanje
    std::for_each(b.begin(), last, [](int x){ std::cout << x << " "; });
    std::cout << std::endl;

    return 0;
}   
