#include <iostream>
// Ukljucujemo zaglavlje algorithm kako bismo mogli da koristimo algoritme standardne biblioteke
#include <algorithm>
#include <vector>

void print(int x)
{
    std::cout << x << " ";
}

int main ()
{
    std::vector<int> a = {1,2,3,4,5,6,7,8,9};

    // Algoritam for_each prolazi kroz kolekciju i za svaki element radi izvrsava funkciju koja se navodi kao 3. argument
    // Na ovaj nacin recimo ispisujemo sve elemente vektora 
    std::for_each(a.begin(), a.end(), [](int x){ std::cout << x << " "; });
    std::cout << std::endl;

    // Isto mozemo i bez lambde
    std::for_each(a.begin(), a.end(), print);
    std::cout << std::endl;

    // Mozemo i da svaki element kolekcije uvecamo za 1
    // Da bismo to uradili x mora da bude poslato po referenci, u suprotnom ce se samo kopija unutar lambde izmeniti a originalna vrednost ce ostati ista
    std::for_each(a.begin(), a.end(), [](int &x){ x++; });
    
    std::for_each(a.begin(), a.end(), [](int x){ std::cout << x << " "; });
    std::cout << std::endl;

    return 0;
}   
