#include <iostream>
// Ukljucujemo zaglavlje algorithm kako bismo mogli da koristimo argumente standardne biblioteke
#include <algorithm>
#include <vector>

int main ()
{
    std::vector<int> a = {1,2,3,4,5,6,7,8,9};
  
    // std::remove_if NE UKLANJA elemente iz kolekcije vec samo one koji treba da budu uklonjeni stavlja na kraj kolekcije
    // Elementi koji se "brisu" su oni koji zadovoljavaju uslov
    // Kao povratnu vrednost dobijamo iterator na prvi element koji treba da bude uklonjen, tj na poziciju za 1 iza poslednjeg elementa koji ostaje u kolekciji
    // Elementi koji ostaju u kolekciji ce ostati u istom redosledu i nakon "uklanjanja" onih koji ne treba da ostanu u kolekciji
    auto last = std::remove_if(a.begin(), a.end(), [](int x){return !(x % 2); });

    // Promeniti last u a.end() i uociti da u kolekciji postoji jos elemenata
    std::for_each(a.begin(), last, [](int x){ std::cout << x << " "; });
    std::cout << std::endl;
    
    // Ako zelimo elemente zaista da obrisemo iz kolekcije koristimo metod erase koji dobija iterator na prvi element od koga pocinje brisanje i iterator na element do koga se brise
    // Kako funkcija erase vraca iterator na prvi element koji treba da bude obrisan taj iterator prosledjujemo kao prvi argument i brisemo do kraja kolekcije
    a.erase(last, a.end());

    // Sada nam ispis do last i ispit do a.end() daju potpuno istu stvar
    std::for_each(a.begin(), last, [](int x){ std::cout << x << " "; });
    std::cout << std::endl;

    std::for_each(a.begin(), a.end(), [](int x){ std::cout << x << " "; });
    std::cout << std::endl;

    return 0;
}   
